Using Array Formulas

Use an array formula to make your worksheet more powerful and simplify it at the same time. The following examples illustrate how you might use array formulas.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

An array formula can do calculations on rows and columns of cells where you might otherwise need to use several formulas. For example:

    // Calculate everyone's total score
    sheet.setArrayFormula(1, 5, 6, 1, 
           '=SUBTOTAL(9,OFFSET($B$2,ROW($A$1:$A$6)-ROW($A$1),,1,3))')

You can use an array formula to help search range items. For example:

    // Find the first value in B1:B5 that does not contain data in A1:A9
    sheet.setArrayFormula(2, 5, 1, 1, 
           '=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))')

An array formula can help collect statistics information from related range items. For example:

    // Summing Sales: Faxes Sold By Brown
    sheet.setArrayFormula(2, 5, 1, 1, 
           '=SUM((A2:A10="Fax")*(B2:B10="Brown")*(C2:C10))');
    // Logical AND (Faxes And Brown)
    sheet.setArrayFormula(5, 5, 1, 1, 
           '=SUM((A2:A10="Fax")*(B2:B10="Brown"))');
An array formula can do calculations on rows and columns of cells where you might otherwise need to use several formulas. For example: You can use an array formula to help search range items. For example: An array formula can help collect statistics information from related range items. For example:
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 3 }); initSpread(spread); }; function initSpread(spread) { var spreadNS = GC.Spread.Sheets; var fbx = new spreadNS.FormulaTextBox.FormulaTextBox(document.getElementById('formulaBar')); fbx.workbook(spread); var oldArrayRange; var arrayFormulaStyle = new spreadNS.Style(); arrayFormulaStyle.backColor = "#E0E0FF"; for (var i = 0; i < spread.sheets.length; i++) { (function (sheet1) { sheet1.bind(spreadNS.Events.SelectionChanged, null, function (args) { sheet1.suspendPaint(); var formulaBar = document.getElementById("formulaBar"); var formulaInfo = sheet1.getFormulaInformation(sheet1.getActiveRowIndex(), sheet1.getActiveColumnIndex()); if (oldArrayRange && (!formulaInfo || !formulaInfo.isArrayFormula || !formulaInfo.baseRange.equals(oldArrayRange))) { for (var r = oldArrayRange.row; r < oldArrayRange.row + oldArrayRange.rowCount; r++) { for (var c = oldArrayRange.col; c < oldArrayRange.col + oldArrayRange.colCount; c++) { sheet1.setStyle(r, c, null); } } oldArrayRange = null; } if (formulaInfo && formulaInfo.hasFormula) { var formula = "=" + formulaInfo.formula; formula = formulaInfo.isArrayFormula ? "{" + formula + "}" : formula; formulaBar.value=formula; if (formulaInfo.isArrayFormula && !formulaInfo.baseRange.equals(oldArrayRange)) { oldArrayRange = formulaInfo.baseRange; for (var r = oldArrayRange.row; r < oldArrayRange.row + oldArrayRange.rowCount; r++) { for (var c = oldArrayRange.col; c < oldArrayRange.col + oldArrayRange.colCount; c++) { sheet1.setStyle(r, c, arrayFormulaStyle); } } } } else { formulaBar.value=sheet1.getValue(sheet1.getActiveRowIndex(), sheet1.getActiveColumnIndex()); } sheet1.resumePaint(); }); })(spread.sheets[i]); } setCalculation(spread.sheets[0]); setSearch(spread.sheets[1]); setStatistics(spread.sheets[2]); } function setCalculation(sheet) { sheet.name("Calculation"); sheet.setArray(0, 0, [ ["", "Match", "Physical", "Chemistry"], ["Alice", 97, 61, 53], ["Jon", 65, 76, 65], ["Bob", 55, 70, 64], ["Jack", 89, 77, 73], ["Tom", 83, 62, 78], ["Robert", 86, 98, 57] ]); sheet.addSpan(0, 5, 1, 4); sheet.setValue(0, 5, "Calculate every body's total score"); sheet.setArrayFormula(1, 5, 6, 1, "=SUBTOTAL(9,OFFSET($B$2,ROW($A$1:$A$6)-ROW($A$1),,1,3))"); } function setSearch(sheet) { sheet.name("Search"); sheet.setArray(0, 0, [ ["apple", "apple"], ["banana", "strawberry"], ["pea", "potato"], ["tomato", "potato"], ["potato", "dumpling"], ["cake"], ["noodle"], ["rice"], ["soup"] ]); sheet.addSpan(0, 3, 1, 8); sheet.setValue(0, 3, "Find out the first value on B1:B5 that does not contains on A1:A9"); sheet.setColumnWidth(3, 80); sheet.addSpan(2, 3, 1, 2); sheet.setValue(2, 3, "ArrayFormula Result:"); sheet.setArrayFormula(2, 5, 1, 1, "=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))"); sheet.getCell(2, 5).backColor("Accent 5 80"); sheet.addSpan(3, 3, 1, 2); sheet.setValue(3, 3, "NormalFormula Result:"); sheet.setFormula(3, 5, "=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))"); sheet.getCell(3, 5).backColor("Accent 6 80"); } function setStatistics(sheet) { sheet.name("Statistics"); sheet.options.allowCellOverflow = true; sheet.setArray(0, 0, [ ["Product", "Salesman", "Units Sold"], ["Fax", "Brown", 1], ["Phone", "Smith", 10], ["Fax", "Jones", 20], ["Fax", "Smith", 30], ["Phone", "Jones", 40], ["PC", "Smith", 50], ["Fax", "Brown", 60], ["Phone", "Davis", 70], ["PC", "Jones", 80] ]); sheet.setValue(1, 5, "Summing Sales: Faxes Sold By Brown"); sheet.setArrayFormula(2, 5, 1, 1, "=SUM((A2:A10=\"Fax\")*(B2:B10=\"Brown\")*(C2:C10))"); sheet.setValue(4, 5, "Logical AND (Faxes And Brown)"); sheet.setArrayFormula(5, 5, 1, 1, "=SUM((A2:A10=\"Fax\")*(B2:B10=\"Brown\"))"); sheet.setValue(7, 5, "Logical OR (Faxes Or Jones)"); sheet.setArrayFormula(8, 5, 1, 1, "=SUM(IF((A2:A10=\"Fax\")+(B2:B10=\"Jones\"),1,0))"); sheet.setValue(10, 5, "Logical XOR (Fax Or Jones but not both)"); sheet.setArrayFormula(11, 5, 1, 1, "=SUM(IF(MOD((A2:A10=\"Fax\")+(B2:B10=\"Jones\"),2),1,0))"); sheet.setValue(13, 5, "Logical AND (All Sales Except Fax And Jones)"); sheet.setArrayFormula(14, 5, 1, 1, "=SUM(IF((A2:A10=\"Fax\")+(B2:B10=\"Jones\")<>2,1,0))"); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets" ></div> <div class="options-container"> <textarea id="formulaBar" rows="10" readonly></textarea> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } textarea { width: 100%; box-sizing: border-box; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

An array formula can do calculations on rows and columns of cells where you might otherwise need to use several formulas. For example:
You can use an array formula to help search range items. For example:
An array formula can help collect statistics information from related range items. For example:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const spreadNS = GC.Spread.Sheets;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
let fbx = new spreadNS.FormulaTextBox.FormulaTextBox(document.getElementById('formulaBar'));
fbx.workbook(spread);
let oldArrayRange;
let arrayFormulaStyle = new spreadNS.Style();
arrayFormulaStyle.backColor = "#E0E0FF";
for (let i = 0; i < spread.sheets.length; i++) {
(function (sheet1) {
sheet1.bind(spreadNS.Events.SelectionChanged, null, function (args) {
sheet1.suspendPaint();
let formulaBar = document.getElementById("formulaBar") as HTMLTextAreaElement;
let formulaInfo = sheet1.getFormulaInformation(sheet1.getActiveRowIndex(), sheet1.getActiveColumnIndex());
if (oldArrayRange && (!formulaInfo || !formulaInfo.isArrayFormula || !formulaInfo.baseRange.equals(oldArrayRange))) {
for (let r = oldArrayRange.row; r < oldArrayRange.row + oldArrayRange.rowCount; r++) {
for (let c = oldArrayRange.col; c < oldArrayRange.col + oldArrayRange.colCount; c++) {
sheet1.setStyle(r, c, null);
}
}
oldArrayRange = null;
}
if (formulaInfo && formulaInfo.hasFormula) {
let formula = "=" + formulaInfo.formula;
formula = formulaInfo.isArrayFormula ? "{" + formula + "}" : formula;
formulaBar.value=formula;
if (formulaInfo.isArrayFormula && !formulaInfo.baseRange.equals(oldArrayRange)) {
oldArrayRange = formulaInfo.baseRange;
for (let r = oldArrayRange.row; r < oldArrayRange.row + oldArrayRange.rowCount; r++) {
for (let c = oldArrayRange.col; c < oldArrayRange.col + oldArrayRange.colCount; c++) {
sheet1.setStyle(r, c, arrayFormulaStyle);
}
}
}
}
else {
formulaBar.value=sheet1.getValue(sheet1.getActiveRowIndex(), sheet1.getActiveColumnIndex());
}
sheet1.resumePaint();
});
})(spread.sheets[i]);
}
this.setCalculation(spread.sheets[0]);
this.setSearch(spread.sheets[1]);
this.setStatistics(spread.sheets[2]);
}
setCalculation(sheet: GC.Spread.Sheets.Worksheet) {
sheet.name("Calculation");
sheet.setArray(0, 0, [
["", "Match", "Physical", "Chemistry"],
["Alice", 97, 61, 53],
["Jon", 65, 76, 65],
["Bob", 55, 70, 64],
["Jack", 89, 77, 73],
["Tom", 83, 62, 78],
["Robert", 86, 98, 57]
]);
sheet.addSpan(0, 5, 1, 4);
sheet.setValue(0, 5, "Calculate every body's total score");
sheet.setArrayFormula(1, 5, 6, 1, "=SUBTOTAL(9,OFFSET($B$2,ROW($A$1:$A$6)-ROW($A$1),,1,3))");
}
setSearch(sheet: GC.Spread.Sheets.Worksheet) {
sheet.name("Search");
sheet.setArray(0, 0, [
["apple", "apple"],
["banana", "strawberry"],
["pea", "potato"],
["tomato", "potato"],
["potato", "dumpling"],
["cake"],
["noodle"],
["rice"],
["soup"]
]);
sheet.addSpan(0, 3, 1, 8);
sheet.setValue(0, 3, "Find out the first value on B1:B5 that does not contains on A1:A9");
sheet.setColumnWidth(3, 80);
sheet.addSpan(2, 3, 1, 2);
sheet.setValue(2, 3, "ArrayFormula Result:");
sheet.setArrayFormula(2, 5, 1, 1, "=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))");
sheet.getCell(2, 5).backColor("Accent 5 80");
sheet.addSpan(3, 3, 1, 2);
sheet.setValue(3, 3, "NormalFormula Result:");
sheet.setFormula(3, 5, "=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))");
sheet.getCell(3, 5).backColor("Accent 6 80");
}
setStatistics(sheet: GC.Spread.Sheets.Worksheet) {
sheet.name("Statistics");
sheet.options.allowCellOverflow = true;
sheet.setArray(0, 0, [
["Product", "Salesman", "Units Sold"],
["Fax", "Brown", 1],
["Phone", "Smith", 10],
["Fax", "Jones", 20],
["Fax", "Smith", 30],
["Phone", "Jones", 40],
["PC", "Smith", 50],
["Fax", "Brown", 60],
["Phone", "Davis", 70],
["PC", "Jones", 80]
]);
sheet.setValue(1, 5, "Summing Sales: Faxes Sold By Brown");
sheet.setArrayFormula(2, 5, 1, 1, "=SUM((A2:A10=\"Fax\")*(B2:B10=\"Brown\")*(C2:C10))");
sheet.setValue(4, 5, "Logical AND (Faxes And Brown)");
sheet.setArrayFormula(5, 5, 1, 1, "=SUM((A2:A10=\"Fax\")*(B2:B10=\"Brown\"))");
sheet.setValue(7, 5, "Logical OR (Faxes Or Jones)");
sheet.setArrayFormula(8, 5, 1, 1, "=SUM(IF((A2:A10=\"Fax\")+(B2:B10=\"Jones\"),1,0))");
sheet.setValue(10, 5, "Logical XOR (Fax Or Jones but not both)");
sheet.setArrayFormula(11, 5, 1, 1, "=SUM(IF(MOD((A2:A10=\"Fax\")+(B2:B10=\"Jones\"),2),1,0))");
sheet.setValue(13, 5, "Logical AND (All Sales Except Fax And Jones)");
sheet.setArrayFormula(14, 5, 1, 1, "=SUM(IF((A2:A10=\"Fax\")+(B2:B10=\"Jones\")<>2,1,0))");
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<textarea id="formulaBar" rows="10" readonly="readonly"></textarea>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
textarea {
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

An array formula can do calculations on rows and columns of cells where you might otherwise need to use several formulas. For example:
You can use an array formula to help search range items. For example:
An array formula can help collect statistics information from related range items. For example:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<textarea id="formulaBar" rows="10" readonly="readonly"></textarea>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
const spreadNS = GC.Spread.Sheets;
function initSpread (spread) {
var fbx = new spreadNS.FormulaTextBox.FormulaTextBox(document.getElementById('formulaBar'));
fbx.workbook(spread);
var oldArrayRange;
var arrayFormulaStyle = new spreadNS.Style();
arrayFormulaStyle.backColor = "#E0E0FF";
for (var i = 0; i < spread.sheets.length; i++) {
(function (sheet1) {
sheet1.bind(spreadNS.Events.SelectionChanged, null, function (args) {
sheet1.suspendPaint();
var formulaBar = document.getElementById("formulaBar");
var formulaInfo = sheet1.getFormulaInformation(sheet1.getActiveRowIndex(), sheet1.getActiveColumnIndex());
if (oldArrayRange && (!formulaInfo || !formulaInfo.isArrayFormula || !formulaInfo.baseRange.equals(oldArrayRange))) {
for (var r = oldArrayRange.row; r < oldArrayRange.row + oldArrayRange.rowCount; r++) {
for (var c = oldArrayRange.col; c < oldArrayRange.col + oldArrayRange.colCount; c++) {
sheet1.setStyle(r, c, null);
}
}
oldArrayRange = null;
}
if (formulaInfo && formulaInfo.hasFormula) {
var formula = "=" + formulaInfo.formula;
formula = formulaInfo.isArrayFormula ? "{" + formula + "}" : formula;
formulaBar.value=formula;
if (formulaInfo.isArrayFormula && !formulaInfo.baseRange.equals(oldArrayRange)) {
oldArrayRange = formulaInfo.baseRange;
for (var r = oldArrayRange.row; r < oldArrayRange.row + oldArrayRange.rowCount; r++) {
for (var c = oldArrayRange.col; c < oldArrayRange.col + oldArrayRange.colCount; c++) {
sheet1.setStyle(r, c, arrayFormulaStyle);
}
}
}
}
else {
formulaBar.value=sheet1.getValue(sheet1.getActiveRowIndex(), sheet1.getActiveColumnIndex());
}
sheet1.resumePaint();
});
})(spread.sheets[i]);
}
setCalculation(spread.sheets[0]);
setSearch(spread.sheets[1]);
setStatistics(spread.sheets[2]);
}
function setCalculation (sheet) {
sheet.name("Calculation");
sheet.setArray(0, 0, [
["", "Match", "Physical", "Chemistry"],
["Alice", 97, 61, 53],
["Jon", 65, 76, 65],
["Bob", 55, 70, 64],
["Jack", 89, 77, 73],
["Tom", 83, 62, 78],
["Robert", 86, 98, 57]
]);
sheet.addSpan(0, 5, 1, 4);
sheet.setValue(0, 5, "Calculate every body's total score");
sheet.setArrayFormula(1, 5, 6, 1, "=SUBTOTAL(9,OFFSET($B$2,ROW($A$1:$A$6)-ROW($A$1),,1,3))");
}
function setSearch (sheet) {
sheet.name("Search");
sheet.setArray(0, 0, [
["apple", "apple"],
["banana", "strawberry"],
["pea", "potato"],
["tomato", "potato"],
["potato", "dumpling"],
["cake"],
["noodle"],
["rice"],
["soup"]
]);
sheet.addSpan(0, 3, 1, 8);
sheet.setValue(0, 3, "Find out the first value on B1:B5 that does not contains on A1:A9");
sheet.setColumnWidth(3, 80);
sheet.addSpan(2, 3, 1, 2);
sheet.setValue(2, 3, "ArrayFormula Result:");
sheet.setArrayFormula(2, 5, 1, 1, "=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))");
sheet.getCell(2, 5).backColor("Accent 5 80");
sheet.addSpan(3, 3, 1, 2);
sheet.setValue(3, 3, "NormalFormula Result:");
sheet.setFormula(3, 5, "=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))");
sheet.getCell(3, 5).backColor("Accent 6 80");
}
function setStatistics (sheet) {
sheet.name("Statistics");
sheet.options.allowCellOverflow = true;
sheet.setArray(0, 0, [
["Product", "Salesman", "Units Sold"],
["Fax", "Brown", 1],
["Phone", "Smith", 10],
["Fax", "Jones", 20],
["Fax", "Smith", 30],
["Phone", "Jones", 40],
["PC", "Smith", 50],
["Fax", "Brown", 60],
["Phone", "Davis", 70],
["PC", "Jones", 80]
]);
sheet.setValue(1, 5, "Summing Sales: Faxes Sold By Brown");
sheet.setArrayFormula(2, 5, 1, 1, "=SUM((A2:A10=\"Fax\")*(B2:B10=\"Brown\")*(C2:C10))");
sheet.setValue(4, 5, "Logical AND (Faxes And Brown)");
sheet.setArrayFormula(5, 5, 1, 1, "=SUM((A2:A10=\"Fax\")*(B2:B10=\"Brown\"))");
sheet.setValue(7, 5, "Logical OR (Faxes Or Jones)");
sheet.setArrayFormula(8, 5, 1, 1, "=SUM(IF((A2:A10=\"Fax\")+(B2:B10=\"Jones\"),1,0))");
sheet.setValue(10, 5, "Logical XOR (Fax Or Jones but not both)");
sheet.setArrayFormula(11, 5, 1, 1, "=SUM(IF(MOD((A2:A10=\"Fax\")+(B2:B10=\"Jones\"),2),1,0))");
sheet.setValue(13, 5, "Logical AND (All Sales Except Fax And Jones)");
sheet.setArrayFormula(14, 5, 1, 1, "=SUM(IF((A2:A10=\"Fax\")+(B2:B10=\"Jones\")<>2,1,0))");
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
textarea {
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

An array formula can do calculations on rows and columns of cells where you might otherwise need to use several formulas. For example:
You can use an array formula to help search range items. For example:
An array formula can help collect statistics information from related range items. For example:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const spreadNS = GC.Spread.Sheets;
export function AppFunc() {
const initSpread = (spread) => {
var fbx = new spreadNS.FormulaTextBox.FormulaTextBox(document.getElementById('formulaBar'));
fbx.workbook(spread);
var oldArrayRange;
var arrayFormulaStyle = new spreadNS.Style();
arrayFormulaStyle.backColor = "#E0E0FF";
for (var i = 0; i < spread.sheets.length; i++) {
(function (sheet1) {
sheet1.bind(spreadNS.Events.SelectionChanged, null, function (args) {
sheet1.suspendPaint();
var formulaBar = document.getElementById("formulaBar");
var formulaInfo = sheet1.getFormulaInformation(sheet1.getActiveRowIndex(), sheet1.getActiveColumnIndex());
if (oldArrayRange && (!formulaInfo || !formulaInfo.isArrayFormula || !formulaInfo.baseRange.equals(oldArrayRange))) {
for (var r = oldArrayRange.row; r < oldArrayRange.row + oldArrayRange.rowCount; r++) {
for (var c = oldArrayRange.col; c < oldArrayRange.col + oldArrayRange.colCount; c++) {
sheet1.setStyle(r, c, null);
}
}
oldArrayRange = null;
}
if (formulaInfo && formulaInfo.hasFormula) {
var formula = "=" + formulaInfo.formula;
formula = formulaInfo.isArrayFormula ? "{" + formula + "}" : formula;
formulaBar.value = formula;
if (formulaInfo.isArrayFormula && !formulaInfo.baseRange.equals(oldArrayRange)) {
oldArrayRange = formulaInfo.baseRange;
for (var r = oldArrayRange.row; r < oldArrayRange.row + oldArrayRange.rowCount; r++) {
for (var c = oldArrayRange.col; c < oldArrayRange.col + oldArrayRange.colCount; c++) {
sheet1.setStyle(r, c, arrayFormulaStyle);
}
}
}
}
else {
formulaBar.value = sheet1.getValue(sheet1.getActiveRowIndex(), sheet1.getActiveColumnIndex());
}
sheet1.resumePaint();
});
})(spread.sheets[i]);
}
setCalculation(spread.sheets[0]);
setSearch(spread.sheets[1]);
setStatistics(spread.sheets[2]);
}
const setCalculation = (sheet) => {
sheet.name("Calculation");
sheet.setArray(0, 0, [
["", "Match", "Physical", "Chemistry"],
["Alice", 97, 61, 53],
["Jon", 65, 76, 65],
["Bob", 55, 70, 64],
["Jack", 89, 77, 73],
["Tom", 83, 62, 78],
["Robert", 86, 98, 57]
]);
sheet.addSpan(0, 5, 1, 4);
sheet.setValue(0, 5, "Calculate every body's total score");
sheet.setArrayFormula(1, 5, 6, 1, "=SUBTOTAL(9,OFFSET($B$2,ROW($A$1:$A$6)-ROW($A$1),,1,3))");
}
const setSearch = (sheet) => {
sheet.name("Search");
sheet.setArray(0, 0, [
["apple", "apple"],
["banana", "strawberry"],
["pea", "potato"],
["tomato", "potato"],
["potato", "dumpling"],
["cake"],
["noodle"],
["rice"],
["soup"]
]);
sheet.addSpan(0, 3, 1, 8);
sheet.setValue(0, 3, "Find out the first value on B1:B5 that does not contains on A1:A9");
sheet.setColumnWidth(3, 80);
sheet.addSpan(2, 3, 1, 2);
sheet.setValue(2, 3, "ArrayFormula Result:");
sheet.setArrayFormula(2, 5, 1, 1, "=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))");
sheet.getCell(2, 5).backColor("Accent 5 80");
sheet.addSpan(3, 3, 1, 2);
sheet.setValue(3, 3, "NormalFormula Result:");
sheet.setFormula(3, 5, "=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))");
sheet.getCell(3, 5).backColor("Accent 6 80");
}
const setStatistics = (sheet) => {
sheet.name("Statistics");
sheet.options.allowCellOverflow = true;
sheet.setArray(0, 0, [
["Product", "Salesman", "Units Sold"],
["Fax", "Brown", 1],
["Phone", "Smith", 10],
["Fax", "Jones", 20],
["Fax", "Smith", 30],
["Phone", "Jones", 40],
["PC", "Smith", 50],
["Fax", "Brown", 60],
["Phone", "Davis", 70],
["PC", "Jones", 80]
]);
sheet.setValue(1, 5, "Summing Sales: Faxes Sold By Brown");
sheet.setArrayFormula(2, 5, 1, 1, "=SUM((A2:A10=\"Fax\")*(B2:B10=\"Brown\")*(C2:C10))");
sheet.setValue(4, 5, "Logical AND (Faxes And Brown)");
sheet.setArrayFormula(5, 5, 1, 1, "=SUM((A2:A10=\"Fax\")*(B2:B10=\"Brown\"))");
sheet.setValue(7, 5, "Logical OR (Faxes Or Jones)");
sheet.setArrayFormula(8, 5, 1, 1, "=SUM(IF((A2:A10=\"Fax\")+(B2:B10=\"Jones\"),1,0))");
sheet.setValue(10, 5, "Logical XOR (Fax Or Jones but not both)");
sheet.setArrayFormula(11, 5, 1, 1, "=SUM(IF(MOD((A2:A10=\"Fax\")+(B2:B10=\"Jones\"),2),1,0))");
sheet.setValue(13, 5, "Logical AND (All Sales Except Fax And Jones)");
sheet.setArrayFormula(14, 5, 1, 1, "=SUM(IF((A2:A10=\"Fax\")+(B2:B10=\"Jones\")<>2,1,0))");
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel />
</div>;
}
function Panel(props) {
return (
<div class="options-container">
<textarea id="formulaBar" rows={10} readOnly="readonly" />
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
const spreadNS = GC.Spread.Sheets;
export class App extends Component {
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel />
</div>;
}
initSpread(spread) {
var fbx = new spreadNS.FormulaTextBox.FormulaTextBox(document.getElementById('formulaBar'));
fbx.workbook(spread);
var oldArrayRange;
var arrayFormulaStyle = new spreadNS.Style();
arrayFormulaStyle.backColor = "#E0E0FF";
for (var i = 0; i < spread.sheets.length; i++) {
(function (sheet1) {
sheet1.bind(spreadNS.Events.SelectionChanged, null, function (args) {
sheet1.suspendPaint();
var formulaBar = document.getElementById("formulaBar");
var formulaInfo = sheet1.getFormulaInformation(sheet1.getActiveRowIndex(), sheet1.getActiveColumnIndex());
if (oldArrayRange && (!formulaInfo || !formulaInfo.isArrayFormula || !formulaInfo.baseRange.equals(oldArrayRange))) {
for (var r = oldArrayRange.row; r < oldArrayRange.row + oldArrayRange.rowCount; r++) {
for (var c = oldArrayRange.col; c < oldArrayRange.col + oldArrayRange.colCount; c++) {
sheet1.setStyle(r, c, null);
}
}
oldArrayRange = null;
}
if (formulaInfo && formulaInfo.hasFormula) {
var formula = "=" + formulaInfo.formula;
formula = formulaInfo.isArrayFormula ? "{" + formula + "}" : formula;
formulaBar.value = formula;
if (formulaInfo.isArrayFormula && !formulaInfo.baseRange.equals(oldArrayRange)) {
oldArrayRange = formulaInfo.baseRange;
for (var r = oldArrayRange.row; r < oldArrayRange.row + oldArrayRange.rowCount; r++) {
for (var c = oldArrayRange.col; c < oldArrayRange.col + oldArrayRange.colCount; c++) {
sheet1.setStyle(r, c, arrayFormulaStyle);
}
}
}
}
else {
formulaBar.value = sheet1.getValue(sheet1.getActiveRowIndex(), sheet1.getActiveColumnIndex());
}
sheet1.resumePaint();
});
})(spread.sheets[i]);
}
this.setCalculation(spread.sheets[0]);
this.setSearch(spread.sheets[1]);
this.setStatistics(spread.sheets[2]);
}
setCalculation(sheet) {
sheet.name("Calculation");
sheet.setArray(0, 0, [
["", "Match", "Physical", "Chemistry"],
["Alice", 97, 61, 53],
["Jon", 65, 76, 65],
["Bob", 55, 70, 64],
["Jack", 89, 77, 73],
["Tom", 83, 62, 78],
["Robert", 86, 98, 57]
]);
sheet.addSpan(0, 5, 1, 4);
sheet.setValue(0, 5, "Calculate every body's total score");
sheet.setArrayFormula(1, 5, 6, 1, "=SUBTOTAL(9,OFFSET($B$2,ROW($A$1:$A$6)-ROW($A$1),,1,3))");
}
setSearch(sheet) {
sheet.name("Search");
sheet.setArray(0, 0, [
["apple", "apple"],
["banana", "strawberry"],
["pea", "potato"],
["tomato", "potato"],
["potato", "dumpling"],
["cake"],
["noodle"],
["rice"],
["soup"]
]);
sheet.addSpan(0, 3, 1, 8);
sheet.setValue(0, 3, "Find out the first value on B1:B5 that does not contains on A1:A9");
sheet.setColumnWidth(3, 80);
sheet.addSpan(2, 3, 1, 2);
sheet.setValue(2, 3, "ArrayFormula Result:");
sheet.setArrayFormula(2, 5, 1, 1, "=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))");
sheet.getCell(2, 5).backColor("Accent 5 80");
sheet.addSpan(3, 3, 1, 2);
sheet.setValue(3, 3, "NormalFormula Result:");
sheet.setFormula(3, 5, "=INDEX(B1:B5,MATCH(TRUE,ISNA(MATCH(B1:B5,A1:A9,0)),0))");
sheet.getCell(3, 5).backColor("Accent 6 80");
}
setStatistics(sheet) {
sheet.name("Statistics");
sheet.options.allowCellOverflow = true;
sheet.setArray(0, 0, [
["Product", "Salesman", "Units Sold"],
["Fax", "Brown", 1],
["Phone", "Smith", 10],
["Fax", "Jones", 20],
["Fax", "Smith", 30],
["Phone", "Jones", 40],
["PC", "Smith", 50],
["Fax", "Brown", 60],
["Phone", "Davis", 70],
["PC", "Jones", 80]
]);
sheet.setValue(1, 5, "Summing Sales: Faxes Sold By Brown");
sheet.setArrayFormula(2, 5, 1, 1, "=SUM((A2:A10=\"Fax\")*(B2:B10=\"Brown\")*(C2:C10))");
sheet.setValue(4, 5, "Logical AND (Faxes And Brown)");
sheet.setArrayFormula(5, 5, 1, 1, "=SUM((A2:A10=\"Fax\")*(B2:B10=\"Brown\"))");
sheet.setValue(7, 5, "Logical OR (Faxes Or Jones)");
sheet.setArrayFormula(8, 5, 1, 1, "=SUM(IF((A2:A10=\"Fax\")+(B2:B10=\"Jones\"),1,0))");
sheet.setValue(10, 5, "Logical XOR (Fax Or Jones but not both)");
sheet.setArrayFormula(11, 5, 1, 1, "=SUM(IF(MOD((A2:A10=\"Fax\")+(B2:B10=\"Jones\"),2),1,0))");
sheet.setValue(13, 5, "Logical AND (All Sales Except Fax And Jones)");
sheet.setArrayFormula(14, 5, 1, 1, "=SUM(IF((A2:A10=\"Fax\")+(B2:B10=\"Jones\")<>2,1,0))");
}
}
class Panel extends Component {
constructor(props) {
super(props);
}
render() {
return (
<div class="options-container">
<textarea id="formulaBar" rows={10} readOnly="readonly" />
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
textarea {
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);